/*
 * Name: kstat lkms.c
 * Date: Sun Feb 10 02:49:49 CET 2002
 * Author: FuSyS [fusys@s0ftpj.org, fusys@sikurezza.org]
 *
 * SoftProject Digital Security for Y2K
 * Sikurezza.org - Italian Security Mailinglist
 *
 * MOJITO-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a mojito.
 *
 * Tested on: Slackware 8 Linux MaNTRa 2.4.16 #4 i686 unknown
 */

#include "linux.h"

int show_lkms()
{
	int kd, i;
	unsigned long addr=0, kaddr=0;
	struct module modk, pmodk;
	char name[50], name2[50];

	system("insmod knull");

	addr=find_module_addr();
	kaddr=find_kmem_offset(IOPORT)-HEXOFF;
	kd=open(KMEM, O_RDONLY);
	if(kread(kd, (unsigned long)addr, &modk, sizeof(struct module)) == -1) err("kread error");
	if(kread(kd, (unsigned long)modk.name, &name, 50) == -1) err("kread error");
	printf("Module              Address");
	printf("\n%-20s%8p\n", name, (void*)addr);

	for(i=0;(unsigned long)modk.next != kaddr;modk.next=pmodk.next,i++){
		memset(&pmodk, 0, sizeof(struct module));
		if(kread(kd, (unsigned long)modk.next, &pmodk, sizeof(struct module)) == -1) err("kread error");
		if(kread(kd, (unsigned long)pmodk.name, &name2, 50) == -1) err("kread error");
		if(pmodk.flags) printf("%-20s%8p\n", name2, modk.next);
	}

	system("rmmod knull");

	return(1);
}

int probe_slkm(unsigned long addr)
{
	int kd;
	struct module stealth;
	struct module_symbol syms;
	char name[50], name2[100];

        kd=open(KMEM, O_RDONLY);
	if(kread(kd, (unsigned long)addr, &stealth, sizeof(struct module)) == -1) err("kread error");
	if(kread(kd, (unsigned long)stealth.name, &name, 50) == -1) err("kread error");
	printf("\nProbing memory at %p\n\n", (void*)addr);
	printf("Name:\t%s\n", name);
	printf("Size:\t%ld\n", stealth.size);
	printf("Flags:\t");
	if(stealth.flags & MOD_UNINITIALIZED)
		printf("MOD_UNINITIALIZED ");
	if(stealth.flags & MOD_RUNNING)
		printf("MOD_RUNNING ");
	if(stealth.flags & MOD_DELETED)
		printf("MOD_DELETED ");
	if(stealth.flags & MOD_AUTOCLEAN)
		printf("MOD_DELETED ");
	if(stealth.flags & MOD_AUTOCLEAN)
		printf("MOD_AUTOCLEAN ");
	if(stealth.flags & MOD_VISITED)
		printf("MOD_VISITED ");
	if(stealth.flags & MOD_USED_ONCE)
		printf("MOD_USED_ONCE ");
	if(stealth.flags & MOD_JUST_FREED)
		printf("MOD_JUST_FREED ");
	printf("\n");
	if(kread(kd, (unsigned long)stealth.syms, &syms, sizeof(struct module_symbol)) == -1) err("kread error");
	if(kread(kd, (unsigned long)syms.name, &name2, 100) == -1) err("kread error");
	printf("First Registered Symbol:\t%s at %p\n\n", name2, (void*)syms.value);
	exit(0);
}
