/*
 * Name: kstat main.c
 * Date: Sun Feb 10 02:49:49 CET 2002
 * Author: FuSyS [fusys@s0ftpj.org, fusys@sikurezza.org]
 *
 * SoftProject Digital Security for Y2K
 * Sikurezza.org - Italian Security Mailinglist
 *
 * MOJITO-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a mojito.
 *
 * Tested on: Slackware 8 Linux MaNTRa 2.4.16 #4 i686 unknown
 */

#include "linux.h"

int main(int argc, char**argv)
{
	int opt, pid;
	unsigned long first;

	if(argc<2) uso(argv[0]);

	while((opt = getopt(argc, argv, "i:p:PMm:sSnr")) != -1) {
		switch(opt)
		{
			case 'i':
				iff=optarg;
				iff_stat();
				break;
			case 'p':
				pid=atoi(optarg);
				show_ps(1, pid);
				break;
			case'P':
				show_ps(0);
				break;
			case'M':
				show_lkms();
				break;
			case 'm':
				first=strtoul(optarg,NULL,0);
				probe_slkm(first);
				break;
			case 's':
				show_syscalls();
				break;
			case 'S':
				fingerprint_syscalls();
				break;
			case 'n':
				show_netprotos();
				break;
			case 'r':
				show_procsyms();
				break;
                        default:
                                printf("Unknown Option.\n\n");
                                exit(0);
                                break;
                }
        }

	printf("\n");
	exit(0);
}
